/*
Copyright (C) 2003  Francesco Stablum "DuskDruid"
<duskdruid @ inventati org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "myheaders.h"

/*extern declarations*/
extern struct flags_t flags;
/*structure for tracking a connection*/

struct conn_t * first_conn=NULL; /*all connections, ends on a 0*/
struct conn_t * last_conn=NULL; 
int conn_num; /* number of active connections */


int * seek_zero(int * ptr)
{
  int count=0; 
   
  while(*ptr&&(count<MAXCONN))
    {
      ptr++;
      count++;
    }
  if(flags.debug)
    printf("*d* seek_zero(): found free pointer at %x\n",ptr);
  return ptr;  
}
int status_switch(struct conn_t * conn,int status)
{
  set_tracked_color(conn->conn_number);
  if(!flags.silent)
    display_status(stdout,conn,status);
  if(flags.writestatus)
    {
      if(!(conn->file_opened))
	open_file(conn);
      display_status(conn->client_file,conn,status);
      display_status(conn->server_file,conn,status);
    }

  conn->status=status;
}

int newconn(struct conn_t * prev_ring,
	    struct in_addr client, 
	    struct in_addr server,
	    u_int32_t seq,
	    u_int16_t client_port,
	    u_int16_t server_port)
{
  struct conn_t* conn;
  conn_num++;
  dprintf("[newconn] new connection(%d):",conn_num);
  dprintf("[newconn] seq: %u",seq);
  dprintf("[newconn] src: %s:%u dst: %s:%u",
	   inet_ntoa(client),
	   ntohs(client_port),
	   inet_ntoa(server),
	   ntohs(server_port)
	   );
  dprintf("[newconn] newtrack(): sizeof(struct conn_t)=%d, conn=%x\n", sizeof(struct conn_t),conn);

  conn=(struct conn_t *)S_calloc(sizeof(struct conn_t),1);
  prev_ring->next_conn=conn; /* and the chain becomes longer... :)
				thank you mainman for this good idea! */
  last_conn=conn;
  dprintf("[newconn] prev_ring->next_conn=conn=%x\n", conn);

  (conn)->client_ip=client.s_addr;
  (conn)->server_ip=server.s_addr;
  (conn)->client_port=client_port;
  (conn)->server_port=server_port;
  (conn)->client_seq=seq;
  (conn)->client_data=(char *)S_calloc(16,1);
  (conn)->server_data=(char *)S_calloc(16,1);
  (conn)->conn_number=conn_num;
  status_switch(conn,1);


}

int data_write(struct conn_t * conn_ptr,
	       u_int32_t data_off, /* offset from beginning */
	       u_char * payload,
	       int payload_len,
	       int part /* client (1) or server (2) ? */
	       )
{
  u_char *new_ptr;
  if (payload_len>0)
    {
      if ((data_off+payload_len)<MAXMALLOC)
	{
	  /* allocating a bigger quantity of memory */
	  if(new_ptr=(u_char *)S_calloc(
			       ((payload_len+data_off)/1024)+1,
				2048/* FIXME: with this as 1024 SEGFAULT: why?*/
			       ))
	    {
	      if (part==1)
		/* client data */
		{
		  /* saving old data */
		  memcpy(new_ptr,
			 conn_ptr->client_data,
			 conn_ptr->client_data_size);
		  /* freeing old-allocated memory */
		  S_free(conn_ptr->client_data);
		  conn_ptr->client_data=new_ptr;
		  /* storing new data */
		  memcpy(conn_ptr->client_data+data_off,payload,payload_len);
		  conn_ptr->client_data_size=data_off+payload_len;
		  
		}
	      else
		/* server data */
		{
		  /* saving old data */
		  memcpy(new_ptr,
			 conn_ptr->server_data,
			 conn_ptr->server_data_size);
		  dprintf("[data_write] The next instruction sometimes goes in segfault!");
		  S_free(conn_ptr->server_data); /* FIXME - BUG sometimes SEGFAULT */
		  conn_ptr->server_data=new_ptr;
		  /* storing new data */
		  memcpy(conn_ptr->server_data+data_off,payload,payload_len);
		  conn_ptr->server_data_size=data_off+payload_len;
		}
	      /* writing to file */
	    }
	  else
	    ;//FIXME:memory not allocated!!!
	  if(flags.file)
	    {
	      if(conn_ptr->file_opened==0)
		open_file(conn_ptr); 
	      if(!flags.writeheaders
		 &&
		 !flags.writestatus
		 &&
		 !flags.writeoffset)
		/* if write header/status is NOT selected */
		{
		  file_write(conn_ptr,part); /* write the whole data */
		}
	      else	      
		/* if write header/status is selected */
		{
		  /* 
		     here should be nothing because not 
		     all packets go to data_write functions, 
		     but only the recognized ones 
		  */
		}
		
	    }
	}
      else
	/* FIXME: add error eprintf*/
	printf("*E* WARNING: VERY BAD ERROR: \n"
	       "*E* data_off: %u payload_len: %u\n",
	       data_off,
	       payload_len);
    }
}
